Index: LMDZ6/trunk/libf/phylmd/infotrac_phy.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/infotrac_phy.F90	(revision 5744)
+++ LMDZ6/trunk/libf/phylmd/infotrac_phy.F90	(revision 5748)
@@ -3,5 +3,5 @@
 MODULE infotrac_phy
 
-   USE       strings_mod, ONLY: msg, maxlen, cat, dispTable, int2str, bool2str, strStack, strParse, strCount, strIdx
+   USE       strings_mod, ONLY: msg, maxlen, cat, dispTable, num2str, strStack, strParse, strCount, strIdx
    USE readTracFiles_mod, ONLY: trac_type, readTracersFiles, tracers,  addPhase,  addKey, iH2O,  &
        isoSelect,  indexUpdate, isot_type, testTracersFiles, isotope,  delPhase,  getKey, tran0, &
@@ -271,6 +271,6 @@
    IF( nqtot /= nqtrue ) THEN
       CALL msg('The choice of advection scheme for one or more tracers makes it necessary to add tracers')
-      CALL msg('The number of true tracers is '//TRIM(int2str(nqtrue)))
-      CALL msg('The total number of tracers needed is '//TRIM(int2str(nqtot)))
+      CALL msg('The number of true tracers is '//TRIM(num2str(nqtrue)))
+      CALL msg('The total number of tracers needed is '//TRIM(num2str(nqtot)))
    END IF
 
@@ -365,17 +365,17 @@
    !=== DISPLAY THE RESULTS
    IF(.NOT.is_master) RETURN
-   CALL msg('nqo    = '//TRIM(int2str(nqo)),    modname)
-   CALL msg('nbtr   = '//TRIM(int2str(nbtr)),   modname)
-   CALL msg('nqtrue = '//TRIM(int2str(nqtrue)), modname)
-   CALL msg('nqtot  = '//TRIM(int2str(nqtot)),  modname)
-   CALL msg('niso   = '//TRIM(int2str(niso)),   modname)
-   CALL msg('ntiso  = '//TRIM(int2str(ntiso)),  modname)
-   CALL msg('nqCO2  = '//TRIM(int2str(nqCO2)),  modname, CPPKEY_INCA)
-   CALL msg('nqINCA = '//TRIM(int2str(nqINCA)), modname, CPPKEY_INCA)
+   CALL msg('nqo    = '//TRIM(num2str(nqo)),    modname)
+   CALL msg('nbtr   = '//TRIM(num2str(nbtr)),   modname)
+   CALL msg('nqtrue = '//TRIM(num2str(nqtrue)), modname)
+   CALL msg('nqtot  = '//TRIM(num2str(nqtot)),  modname)
+   CALL msg('niso   = '//TRIM(num2str(niso)),   modname)
+   CALL msg('ntiso  = '//TRIM(num2str(ntiso)),  modname)
+   CALL msg('nqCO2  = '//TRIM(num2str(nqCO2)),  modname, CPPKEY_INCA)
+   CALL msg('nqINCA = '//TRIM(num2str(nqINCA)), modname, CPPKEY_INCA)
    t => tracers
    CALL msg('Information stored in '//TRIM(modname)//': ', modname)
    IF(dispTable('issssssssiiiiiiii', ['iq  ', 'name', 'lNam', 'g0Nm', 'prnt', 'type', 'phas', 'comp',      &
                               'isPh', 'iGen', 'iqPr', 'nqDe', 'nqCh', 'iGrp', 'iNam', 'iZon', 'iPha'],     &
-      cat(t%name, t%longName, t%gen0Name, t%parent, t%type, t%phase, t%component, bool2str(t%isInPhysics)),&
+      cat(t%name, t%longName, t%gen0Name, t%parent, t%type, t%phase, t%component, num2str(t%isInPhysics)), &
       cat([(iq, iq=1, nqtot)], t%iGeneration, t%iqParent, t%nqDescen, t%nqChildren, t%iso_iGroup,          &
                   t%iso_iName, t%iso_iZone, t%iso_iPhase), nColMax=maxTableWidth, nHead=2, sub=modname))   &
@@ -390,11 +390,11 @@
 
    IF(CPPKEY_STRATAER .AND. type_trac == 'coag') THEN
-      CALL msg('nbtr_bin       ='//TRIM(int2str(nbtr_bin      )), modname)
-      CALL msg('nbtr_sulgas    ='//TRIM(int2str(nbtr_sulgas   )), modname)
-      CALL msg('id_BIN01_strat ='//TRIM(int2str(id_BIN01_strat)), modname)
-      CALL msg('id_OCS_strat   ='//TRIM(int2str(id_OCS_strat  )), modname)
-      CALL msg('id_SO2_strat   ='//TRIM(int2str(id_SO2_strat  )), modname)
-      CALL msg('id_H2SO4_strat ='//TRIM(int2str(id_H2SO4_strat)), modname)
-      CALL msg('id_TEST_strat  ='//TRIM(int2str(id_TEST_strat )), modname)
+      CALL msg('nbtr_bin       ='//TRIM(num2str(nbtr_bin      )), modname)
+      CALL msg('nbtr_sulgas    ='//TRIM(num2str(nbtr_sulgas   )), modname)
+      CALL msg('id_BIN01_strat ='//TRIM(num2str(id_BIN01_strat)), modname)
+      CALL msg('id_OCS_strat   ='//TRIM(num2str(id_OCS_strat  )), modname)
+      CALL msg('id_SO2_strat   ='//TRIM(num2str(id_SO2_strat  )), modname)
+      CALL msg('id_H2SO4_strat ='//TRIM(num2str(id_H2SO4_strat)), modname)
+      CALL msg('id_TEST_strat  ='//TRIM(num2str(id_TEST_strat )), modname)
    END IF
 
Index: LMDZ6/trunk/libf/phylmd/phyetat0_get_mod.f90
===================================================================
--- LMDZ6/trunk/libf/phylmd/phyetat0_get_mod.f90	(revision 5744)
+++ LMDZ6/trunk/libf/phylmd/phyetat0_get_mod.f90	(revision 5748)
@@ -122,5 +122,5 @@
   USE iostart,           ONLY: get_field
   USE print_control_mod, ONLY: lunout
-  USE strings_mod,       ONLY: int2str, maxlen
+  USE strings_mod,       ONLY: num2str, maxlen
   IMPLICIT NONE
   REAL,             INTENT(INOUT) :: field(:,:,:)
@@ -133,6 +133,6 @@
   IF(SIZE(field,3)>99) CALL abort_physic("phyetat0", "Too much sub-cells", 1)
   DO nsrf = 1, SIZE(field,3)
-    DO i = 1, SIZE(name); nam(i) = TRIM(name(i))//TRIM(int2str(nsrf,2)); END DO
-    des = TRIM(descr)//" srf:"//int2str(nsrf,2)
+    DO i = 1, SIZE(name); nam(i) = TRIM(name(i))//TRIM(num2str(nsrf,2)); END DO
+    des = TRIM(descr)//" srf:"//num2str(nsrf,2)
     lFound = phyetat0_get21(field(:,:,nsrf), nam, TRIM(des), default, tname)
   END DO
Index: LMDZ6/trunk/libf/phylmd/phytrac_mod.f90
===================================================================
--- LMDZ6/trunk/libf/phylmd/phytrac_mod.f90	(revision 5744)
+++ LMDZ6/trunk/libf/phylmd/phytrac_mod.f90	(revision 5748)
@@ -128,5 +128,5 @@
     USE dimphy
     USE infotrac_phy, ONLY: nbtr, nqCO2, type_trac, conv_flg, pbl_flg
-    USE strings_mod,  ONLY: int2str
+    USE strings_mod,  ONLY: num2str
     USE mod_grid_phy_lmdz
     USE mod_phys_lmdz_para
@@ -735,5 +735,5 @@
           ENDDO
 
-          CALL minmaxqfi(tr_seri(:,:,it),0.,1.e33,'convection it = '//TRIM(int2str(it)))
+          CALL minmaxqfi(tr_seri(:,:,it),0.,1.e33,'convection it = '//TRIM(num2str(it)))
 
        ENDDO ! nbtr
@@ -939,5 +939,5 @@
                 ENDDO
              ENDDO
-             CALL minmaxqfi(tr_seri(:,:,it),0.,1.e33,'lsc scav it = '//TRIM(int2str(it)))
+             CALL minmaxqfi(tr_seri(:,:,it),0.,1.e33,'lsc scav it = '//TRIM(num2str(it)))
              ENDIF
 
Index: LMDZ6/trunk/libf/phylmd/traclmdz_mod.f90
===================================================================
--- LMDZ6/trunk/libf/phylmd/traclmdz_mod.f90	(revision 5744)
+++ LMDZ6/trunk/libf/phylmd/traclmdz_mod.f90	(revision 5748)
@@ -312,5 +312,5 @@
     USE dimphy
     USE infotrac_phy, ONLY: nbtr, pbl_flg
-    USE strings_mod,  ONLY: int2str
+    USE strings_mod,  ONLY: num2str
     USE regr_pr_comb_coefoz_m, ONLY: regr_pr_comb_coefoz
     USE o3_chem_m, ONLY: o3_chem
@@ -558,5 +558,5 @@
              END DO
           END DO
-          CALL minmaxqfi(tr_seri(:,:,it),0.,1.e33,'puits rn it='//TRIM(int2str(it)))
+          CALL minmaxqfi(tr_seri(:,:,it),0.,1.e33,'puits rn it='//TRIM(num2str(it)))
        END IF
     END DO